Package org.apache.sysds.runtime.controlprogram.parfor.opt

## Class CostEstimatorRuntime

- java.lang.Object
- - org.apache.sysds.runtime.controlprogram.parfor.opt.CostEstimator
  - - org.apache.sysds.runtime.controlprogram.parfor.opt.CostEstimatorRuntime

-     public class CostEstimatorRuntime
      extends CostEstimator

  Cost estimator for runtime programs. Previously this estimator used an offline created performance profile. Since SystemDS 1.0, this estimator uses a time-based cost model that relies on floating operations and I/O, which does not require explicit profiling.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.controlprogram.parfor.opt.CostEstimator

      `CostEstimator.DataFormat, CostEstimator.ExcludeType, CostEstimator.TestMeasure`

  - ### Field Summary

    - ### Fields inherited from class org.apache.sysds.runtime.controlprogram.parfor.opt.CostEstimator

      `DEFAULT_EST_PARALLELISM, DEFAULT_MEM_ESTIMATE_CP, DEFAULT_MEM_ESTIMATE_SP, DEFAULT_TIME_ESTIMATE, FACTOR_NUM_ITERATIONS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CostEstimatorRuntime​(OptTreePlanMappingAbstract map, LocalVariableMap vars)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `getLeafNodeEstimate​(CostEstimator.TestMeasure measure, OptNode node)` | Main leaf node estimation method - to be overwritten by specific cost estimators
    `double` | `getLeafNodeEstimate​(CostEstimator.TestMeasure measure, OptNode node, Types.ExecType et)` | Main leaf node estimation method - to be overwritten by specific cost estimators

    - ### Methods inherited from class org.apache.sysds.runtime.controlprogram.parfor.opt.CostEstimator

      `getEstimate, getEstimate, getEstimate, getEstimate`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CostEstimatorRuntime

          public CostEstimatorRuntime​(OptTreePlanMappingAbstract map,
                                      LocalVariableMap vars)

  - ### Method Detail

    - #### getLeafNodeEstimate

          public double getLeafNodeEstimate​(CostEstimator.TestMeasure measure,
                                            OptNode node)

      Description copied from class: `CostEstimator`
      Main leaf node estimation method - to be overwritten by specific cost estimators
      Specified by:
        `getLeafNodeEstimate` in class `CostEstimator`
      Parameters:
        `measure` - ?
        `node` - internal representation of a plan alternative for program blocks and instructions
      Returns:
        estimate?

    - #### getLeafNodeEstimate

          public double getLeafNodeEstimate​(CostEstimator.TestMeasure measure,
                                            OptNode node,
                                            Types.ExecType et)

      Description copied from class: `CostEstimator`
      Main leaf node estimation method - to be overwritten by specific cost estimators
      Specified by:
        `getLeafNodeEstimate` in class `CostEstimator`
      Parameters:
        `measure` - ?
        `node` - internal representation of a plan alternative for program blocks and instructions
        `et` - forced execution type for leaf node
      Returns:
        estimate?